﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using GASS.CUDA.Types;

namespace Visualizator.Physics
{
    /// <summary>
    /// Define la interfaz publica de un integrador Verlet, es decir
    /// un integrador que recibe la posicion actual y la posicion anterior
    /// y calcula una nueva posicion.
    /// </summary>
    public interface IVerletIntegrator
    {
        Float4[] Pos { get; set; }
        Float4[] PrevPos { get; set; }

        int ParticleCount { get; set; }

        void Integrate(float dt);
        void Initialize();
    }
}
